<?php

/*********************************************************************

 ページタグクラウド表示プラグイン (2010/11/18)

 Copyright(C) 2009-2010 freo.jp

*********************************************************************/

/* メイン処理 */
function freo_end_page_tagcloud()
{
	global $freo;

	//ページタグ取得
	$stmt = $freo->pdo->prepare('SELECT tag FROM ' . FREO_DATABASE_PREFIX . 'pages WHERE approved = \'yes\' AND (status = \'publish\' OR (status = \'future\' AND datetime <= :now1)) AND display = \'publish\' AND tag IS NOT NULL AND (close IS NULL OR close >= :now2)');
	$stmt->bindValue(':now1', date('Y-m-d H:i:s'));
	$stmt->bindValue(':now2', date('Y-m-d H:i:s'));
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$page_tags = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		foreach (explode(',', $data['tag']) as $tag) {
			if ($tag == '') {
				continue;
			}

			if (isset($page_tags[$tag])) {
				$page_tags[$tag]++;
			} else {
				$page_tags[$tag] = 1;
			}
		}
	}

	ksort($page_tags, SORT_STRING);

	$data = '';
	foreach ($page_tags as $tag => $count) {
		$data .= "$tag,$count\n";
	}

	//ページタグ情報更新
	if (file_put_contents(FREO_FILE_DIR . 'plugins/page_tagcloud.log', $data) === false) {
		freo_error('ページタグ情報保存ファイル ' . FREO_FILE_DIR . 'plugins/page_tagcloud.log に書き込めません。');
	}

	return;
}

?>
